// -------------------------------------------------------------------------------
// 
// 		cwCu		EChEvOwb_t@C
// 
// 				Ver 3.17a
// 
// -------------------------------------------------------------------------------

#ifndef __DXWINDOW_H__
#define __DXWINDOW_H__

// CN[h ------------------------------------------------------------------
#include "../DxCompileConfig.h"
#include "../DxLib.h"
#include "../DxMemory.h"
#include "../DxFile.h"
#include "../DxThread.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define WIN_MOUSEINPUT_LOG_NUM		(32)				// ێ}EX̃NbN

#define MAX_MENUITEMSELECT_NUM		(64)				// ێĂIꂽj[ڂ̍ő吔
#define MAX_MENUITEM_NUM			(128)				// j[ڂ̍ő吔
#define MAX_ACCELERATOR_NUM			(64)				// ANZ[^̍ő吔
#define MAX_TOOLBARITEM_NUM			(64)				// c[o[ɒuACe̍ő吔

#define MAX_MESTAKEOVERWIN_NUM		(100)				// bZ[WvZX肷EChE̍ő吔
#define MAX_DRAGFILE_NUM			(1000)				// hbO&hbvꂽt@Cۑō
#define MAX_THREADWAIT_NUM			(4096)				// ɑ҂ƂoXbh̍ő吔

typedef HHOOK 						( *MSGFUNC )( HWND MainWindow, HHOOK *pKeyboardHookHandle, int Enable ) ;		// bZ[WtbNݒ֐

#define WSA_WINSOCKMESSAGE 			(WM_USER + 261)

// \̒` --------------------------------------------------------------------

// j[ڂ̏
struct WINMENUITEMINFO
{
	HMENU					Menu ;								// j[
	short					Index ;								// io[
	unsigned short			ID ;								// hc
	wchar_t					Name[128] ;							// O
} ;

// c[o[ڂ̏
struct WINTOOLBARITEMINFO
{
	int						ID ;								// ID
	int						ImageIndex ;						// 摜̃CfbNX
	int						Type ;								// ^Cv
	int						State ;								// 
	int						Click ;								// NbNꂽ
} ;

// ob̏
struct PCINFO
{
	wchar_t					OSString[256] ;						// nr̋Lq
	wchar_t					DirectXString[256] ;				// cw̋Lq
	wchar_t					CPUString[256] ;					// bot̋Lq
	int						CPUSpeed ;							// bot̑x(PMHz)
	LONGLONG				FreeMemorySize ;					// 󂫃TCY(Pbyte)
	LONGLONG				TotalMemorySize ;					// TCY(Pbyte)
	wchar_t					VideoDriverFileName[256] ;			// rfIJ[hhCot@C
	wchar_t					VideoDriverString[256] ;			// rfIJ[hhCőLq
	unsigned int			VideoFreeMemorySize ;				// 󂫂uq`lTCY(Pbyte)
	unsigned int			VideoTotalMemorySize ;				// uq`l̑TCY(Pbyte)
} ;

#ifndef DX_NON_INPUT
// }EX̓͏
struct WINMOUSEINPUT
{
	int						Button ;							// NbN{^
	int						ClickX, ClickY ;					// NbNNCAgW
} ;
#endif // DX_NON_INPUT

// EChEnf[^\
struct WINDATA
{
	PCINFO					PcInfo ;							// ob̏
	HINSTANCE				Instance ;							// \tg̃CX^Xnh
	HWND					MainWindow ;						// CEChEnh
	HWND					UserChildWindow ;					// \pqEChEnh

	int						ProcessorNum ;						// _botRA̐
	int						AeroDisableFlag ;					// Aero𖳌ɂĂ邩ǂ̃tO
	int						SystembarHeight ;					// VXeo[̍

#ifdef DX_THREAD_SAFE
	HANDLE					ProcessMessageThreadHandle ;		// ProcessMessage ЂĂтÂvZX̃nh
	DWORD					ProcessMessageThreadID ;			// ProcessMessage ЂĂтÂvZX̂hc
	DWORD					ProcessMessageThreadExitFlag ;		// ProcessMessage ЂĂтÂvZXIɗĂtO
#endif

	HRGN					WindowRgn ;							// CEChẼ[W
	int						WindowStyle ;						// EChẼX^C^CvCfbNXl
	int						WindowZType ;						// EChÊyI[_[^Cv( DX_WIN_ZTYPE_NORMAL Ȃ )
	int						UserWindowFlag ;					// MainWindow ͂cwCu쐬EChEł͂ȂAtO(sqtdF[U[nꂽEChE  e`krdFcwCu쐬EChE)
	int						NotUserWindowMessageProcessDXLibFlag ;	// UserWindowFlag ĂꍇAEChẼbZ[WcwCusȂǂAtO(sqtdFcwCu͉[U[bZ[Ws@e`krdFcwCus)
	WNDPROC					DefaultUserWindowProc ;				// cwCũvV[Wݒ肷OɃ[U[̃EChEɐݒ肳ĂvV[W
	DWORD					MainThreadID ;						// InitializeWindow ĂяoXbĥhc


	RECT					WindowEdgeRect ;					// EChE[hœ삵Ă鎞̃EChE̋`̈
	RECT					WindowRect ;						// EChE[hœ삵Ă鎞̃EChẼNCAg̈
	int						WindowModeFlag ;					// EChE[hœ삵Ă邩ÃtO
	int						ChangeWindodwFlag ;					// EChE[hɕύXAtO
	int						UseChangeWindowModeFlag ;			// ALT+ENTER ɂtXN[EChE̕ύX@\Lł邩tO
	void					(*ChangeWindowModeCallBackFunction)(void *) ; // tXN[EChE̕ύXNƂɌĂԊ֐
	void					*ChangeWindowModeCallBackFunctionData ;	// tXN[EChE̕ύXNƂɌĂԊ֐ɓnf[^
	void					(*ShutdownCallBackFunction)(void *) ; // Vbg_Eɂ\tg̋IۂɌĂ΂R[obN֐
	void					*ShutdownCallBackFunctionData ;		// Vbg_Eɂ\tg̋IۂɌĂ΂R[obN֐ɓnf[^
	wchar_t					ShutdownMessage[ 512 ] ;			// Vbg_Eɂ\tg̋IۂɌĂ΂R[obN֐̏sĂԂɕ\郁bZ[W

	wchar_t					InputSysChara ;						// ͂ꂽVXeR[h

	int						QuitMessageFlag ;					// WM_QUITbZ[WĂǂ̃tOϐ
	int						CloseMessagePostFlag ;				// WM_CLOSEbZ[W𑗂ɂsqtdɂȂtOϐ
	int						DestroyMessageCatchFlag ;			// WM_DESTROY bZ[WɂsqtdɂȂtOϐ
	int						DisplayChangeMessageFlag ;			// WM_DISPLAYCHANGE bZ[WtO
	
	int						ScreenCopyRequestFlag ;				// ScreenCopy ė~ǂ̃tO
	int						ScreenCopyRequestStartTime ;		// ScreenCopy ė~ǂ̃tOƂ̎
	int						ActiveFlag ;						// s̃\tgANeBuԂisqtdFANeBu e`krdFANeBuj
	int						WindowMinSizeFlag ;					// ŏĂ邩ǂ̃tO
	int						WaitTimeValidFlag ;					// WaitTime Lǂ̃tO
	int						WaitTime ;							// ̃\tgANeBuɂȂA\tg~n߂̃JEg
	int						StopFlag ;							// ꎞIɃIuWFNg[XĂ邩tO
	int						ChangeWindowModeFlag ;				// EChE[h̕ύXsw肪NsqtdɂȂtO
	int						NonUserCloseEnableFlag ;			// [U[~{^ɃCuŃEChE邩ǂ̃tO
	int						NonDxLibEndPostQuitMessageFlag ;	//cwCȕI PostQuitMessage Ă΂Ȃǂ̃tO
	int						AltF4_EndFlag ;						// IAtO
	int						WM_PAINTFlag ;						// WM_PAINT AtO
	int						RecvWM_PAINTFlag;					// WM_PAINT ǂAtO
	int						NotUseDxLibWM_PAINTProcess ;		// cwCu WM_PAINT ̏sȂ̃tO
	int						UseFPUPreserve ;					// FPUx𗎂ƂȂݒgp邩ǂ( TRUE:gp  FALSE:gpȂ )

	int						MouseDispFlag ;						// }EX̕\tO
	int						MouseDispState ;					// }EX̕\
	int						MouseMoveZ ;						// }EX̃zC[̈ړ
	int						MouseMoveHZ ;						// }EX̐zC[̈ړ
#ifndef DX_NON_INPUT
	int						MouseInputNum ;						// }EX̓͏̐
	WINMOUSEINPUT			MouseInput[ WIN_MOUSEINPUT_LOG_NUM ] ;	// }EX̓͏
#endif // DX_NON_INPUT

	int						WM_ACTIVATE_StockNum ;				// WM_ACTIVATE bZ[WXgbN̐
	int						WM_ACTIVATE_StartIndex ;			// WM_ACTIVATE bZ[WOobt@̊JnCfbNX
	int						WM_ACTIVATE_EndIndex ;				// WM_ACTIVATE bZ[WOobt@̏ICfbNX
	WPARAM					WM_ACTIVATE_wParam[ 512 ] ;			// WM_ACTIVATE ɃbZ[WՂ wParam
	LPARAM					WM_ACTIVATE_lParam[ 512 ] ;			// WM_ACTIVATE ɃbZ[WՂ lParam
	int						WM_ACTIVATE_APPMes[ 512 ] ;			// WM_ACTIVATEAPP ̌肩
	int						WM_ACTIVATE_Dummy[ 512 ] ;			// WM_ACTIVATE ̃_~[bZ[Wǂ

	int						PerformanceTimerFlag ;				// ptH[}XJE^[g邩tO
	LONGLONG				PerformanceClock ;					// ptH[}XJE^[̎g

//	SIZE					DefaultScreenSize ;					// ÑfXNgbv̉ʃTCY
//	int						DefaultColorBitCount ;				// ÑfXNgbṽJ[rbg
//	int						DefaultRefreshRate ;				// ÑfXNgbṽtbV[g

	int						ComInitializeFlag ;					// bnlÃtO
	int						WindowCreateFlag ;					// EChE쐬AtO
	int						ProcessMessageFlag ;				// ProcessMessage sAtO
	int						DoubleStartValidFlag ;				// QdNǂ̃tO(TRUE: FALSE:Ȃ)

	BASEIMAGE				PauseGraph ;						// ANeBuɈڂĂƂɕ`悷摜
	int						PauseGraphHandle ;					// ANeBuɈڂĂƂɕ`悷摜̃OtBbNnh
	int						(*ActiveStateChangeCallBackFunction)( int ActiveState, void *UserData ) ;	// EChẼANeBuԂɕωƂɌĂ΂֐
	void					*ActiveStateChangeCallBackFunctionData ;	// ActiveStateChangeCallBackFunction ɓnf[^AhX

	wchar_t					CurrentDirectory[ FILEPATH_MAX ] ;	// ÑJgfBNg
	int						EnableWindowText ;					// WindowText Lǂ
	wchar_t					WindowText[ 256 ] ;					// CEChEeLXg
	wchar_t					ClassName[ 256 ] ;					// CEChẼNX

	int						NonActiveRunFlag ;					// EChEANeBuł͂ȂĂs邩ǂ̃tO
	int						DrawBackGraphFlag ;					// DrawBackGraph ֐sǂ( TRUE:s  FALSE:sł͂Ȃ )

	int						IconID ;							// gpACR̂hc
	HICON					IconHandle ;						// gpACR̃nh

	int						UseAccelFlag ;						// ANZ[^[gp邩ǂtO
	HACCEL					Accel ;								// ANZ[^[

	HMENU					Menu ;								// gpĂ郁j[̃nh
	int						MenuSetupFlag ;						// j[ZbgĂ邩ǂtO( TRUE:ZbgĂ  FALSE:ĂȂ )
	int						MenuUseFlag ;						// j[gpĂ邩tO
	int						MenuResourceID ;					// j[̃\[Xhc
	int						(*MenuProc)( WORD ID ) ;			// j[bZ[W̃R[obN֐
	void					(*MenuCallBackFunction)( const TCHAR *ItemName, int ItemID ) ;	// j[bZ[W̃R[obN֐
	int						NotMenuDisplayFlag ;				// j[\tO
	int						MenuDisplayState ;					// j[\Ă邩ǂtO
	int						NotMenuAutoDisplayFlag ;			// j[ŕ\肵Ȃ肷
	int						MousePosInMenuBarFlag ;				// j[o[̗̈Ƀ}EX|C^Ă邩AtO
	int						SelectMenuItem[MAX_MENUITEMSELECT_NUM] ; // Iꂽj[ڂ̃Xg
	int						SelectMenuItemNum ;					// Iꂽj[ڂ̐
	WINMENUITEMINFO			MenuItemInfo[MAX_MENUITEM_NUM] ;	// j[̑Iڂ̏
	int						MenuItemInfoNum ;					// j[̑Iڂ̐

	int						ToolBarUseFlag ;					// c[o[gp邩ǂ̏
	HWND					ToolBarHandle ;						// c[o[̃EChEnh
	HBITMAP					ToolBarButtonImage ;				// c[o[̃{^̃rbg}bv
	int						ToolBarItemNum ;					// c[o[̃ACe̐
	WINTOOLBARITEMINFO		ToolBarItem[MAX_TOOLBARITEM_NUM] ;	// c[o[̃{^̏

	int						WindowSizeChangeEnable ;			// EChẼTCYύXł邩tO
	double					WindowSizeExRateX, WindowSizeExRateY ;	// `ʂ̃TCYɑ΂EChETCY̔䗦
	int						ScreenNotFitWindowSize ;			// EChẼNCAg̈ɉʂtBbgȂǂtO( TRUE:tBbgȂ  FALSE:tBbg )
	int						WindowWidth, WindowHeight ;			// EChẼTCY( [U[w )
	int						WindowSizeValid ;					// EChẼTCYLǂ( TRUE:L  FALSE: )
	int						WindowSizeValidResetRequest ;		// EChẼTCYLǂ̃tOZbg郊NGXgtO
	int						WindowX, WindowY ;					// EChËʒu( [U[w )
	int						WindowPosValid ;					// EChËʒuLǂ( TRUE:L  FALSE: )
	int						WindowMaxWidth, WindowMaxHeight ;	// EChE̍őTCY( [U[w )
	int						WindowMaxSizeValid ;				// EChE̍őTCYLǂ( TRUE:L  FALSE: )
	int						WindowMinWidth, WindowMinHeight ;	// EChE̍ŏTCY( [U[w )
	int						WindowMinSizeValid ;				// EChE̍ŏTCYLǂ( TRUE:L  FALSE: )

	int						VisibleFlag ;
	int						NotWindowVisibleFlag ;				// EChE\ȂtO
	int						WindowMinimizeFlag ;				// EChEŏԂɂ邩ǂ̃tO
	int						WindowMaximizeFlag ;				// EChEő剻Ԃɂ邩ǂ̃tO
	RECT					WindowMaximizedClientRect ;			// EChEő剻Ԃł̃NCAg`
	RECT					WindowMaximizedRect ;				// EChEő剻Ԃł̃EChE`
	RECT					WindowMaximizedAdjustRect ;			// EChEő剻Ԃł̃EChE`cwCuŕ␳
	int						ValidFirstWindowMaximizedRect ;		// ԍŏ̍ő剻Ԃł̃EChE̋`Lǂ( TRUE:L  FALSE: )
	RECT					FirstWindowMaximizedRect ;			// ԍŏ̍ő剻Ԃł̃EChE̋`
	int						NotMoveMousePointerOutClientAreaFlag ;	// EChẼNCAgGAOɃ}EX|C^ړłȂ悤ɂ邩ǂ̃tO
	int						NotActive_WindowMoveOrSystemMenu ;	// WM_ENTERSIZEMOVE  WM_ENTERMENULOOP ɂĔANeBuɂȂĂ
	int						SetClipCursorFlag ;					// ClipCursor ̐ݒ肪LɂȂĂ邩ǂtO
	int						SysCommandOffFlag ;					// ^XNXCb`}鏈stO
	HHOOK					TaskHookHandle ;					// tbNnh
	HHOOK					GetMessageHookHandle ;				// WH_GETMESSAGE tbNnh
	HHOOK					KeyboardHookHandle ;				// WH_KEYBOARD_LL tbNnh
	int						LockInitializeFlag ;				// bNƂtO
	wchar_t					HookDLLFilePath[FILEPATH_MAX] ;		// tbNckkt@Cւ̃pX
	int						NotUseUserHookDllFlag ;				// [U[ŵckkgpĂȂǂtO
	HMODULE					LoadResourModule ;					// \[XǂݍތnŎgp郂W[( NULL ̏ꍇ GetModuleHandle( NULL ) gp )
	int						WM_PAINTMessageFlag ;				// WM_PAINT bZ[Wۂ TRUE ɂȂtO

	int						BackBufferTransColorFlag ;			// obNobt@̓ߐF̕𓧉߂邩ǂ̃tO( TRUE:߂  FALSE:߂Ȃ )
	int						UseUpdateLayerdWindowFlag ;			// UpdateLayerdWindow gp邩ǂ̃tO( TRUE;gp  FALSE:gpȂ )
	HBITMAP					BackBufferTransBitmap ;				// obNobt@̓ߐF̕𓧉߂邽߂̃rbg}bv
	void					*BackBufferTransBitmapImage ;		// BackBufferTransBitmap ̃C[W̐擪AhX
	SIZE					BackBufferTransBitmapSize ;			// BackBufferTransBitmap ̃TCY
	COLORDATA				BackBufferTransBitmapColorData ;	// BackBufferTransBitmap ̃J[tH[}bg

	HINSTANCE				MessageHookDLL ;					// bZ[WtbNckk̃nh
	MSGFUNC					MessageHookCallBadk ;				// bZ[WtbÑR[obN֐
	DWORD					MessageHookThredID ;				// bZ[WtbNckk̃Xbhhc

	int						DirectXVersion ;					// DirectX̃o[W
	int						WindowsVersion ;					// Windows̃o[W
	int						UseMMXFlag ;						// MMXg邩tO
	int						UseSSEFlag ;						// SSEg邩ǂtO
	int						UseSSE2Flag ;						// SSE2g邩ǂtO
	int						UseRDTSCFlag ;						// RDTSC ߂g邩AtO
	LONGLONG				OneSecCount ;						// bԂ̃NbN

	WNDPROC					UserWindowProc ;					// [U[`̃EChEv[W
	int						UseUserWindowProcReturnValue ;		// [U[`̃EChEv[W̖߂lgp邩ǂ( TRUE:gp  FALSE:gpȂ )

	HWND					MesTakeOverWindow[MAX_MESTAKEOVERWIN_NUM] ;	// bZ[W肷EChẼXg
	int						MesTakeOverWindowNum ;				// bZ[W肷EChE̐
	
	POINT					InitializeWindowPos ;				// EChËʒu
	int						InitializeWindowPosValidFlag ;		// EChËʒu̍W̗LtO
	
	HWND					DialogBoxHandle ;					// _CAO{bNX̃nh
	
	int						DragFileValidFlag ;					// t@C̃hbOhbvtO
	wchar_t					*DragFileName[MAX_DRAGFILE_NUM] ;	// hbOhbvꂽt@C
	int						DragFileNum ;						// hbOhbvꂽt@C̐

//	WINFILEACCESS			*ReadOnlyFileAccessFirst ;			// t@CANZX\̃Xg̐擪ւ̃|C^
//	int						ReadOnlyFileAccessLockFlag ;		// t@CANZX\̃Xgւ̃ANZX֎~Ă邩AtO

#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )
//	int						DxConflictCheckFlag ;				// cwCů֐̃^XN瓯ɎsȂ悤ɂ邽߂̃JE^̂P
	int						DxConflictCheckCounter ;			// cwCů֐̃^XN瓯ɎsȂ悤ɂ邽߂̃JE^̂Q
	int						DxUseThreadFlag ;					// cwCugpĂXbh邩ǂAtO( FALSE:Ȃ  TRUE: )
	DWORD					DxUseThreadID ;						// cwCugpĂXbĥhc
	DWORD_PTR				DxConflictWaitThreadID[MAX_THREADWAIT_NUM][2] ;	// 0:҂XbhID  1:Cxgnh
	int						DxConflictWaitThreadIDInitializeFlag ;	// DxConflictWaitThreadID Ă邩ǂ̃tO
	int						DxConflictWaitThreadNum ;			// ҂Xbh̐
	DX_CRITICAL_SECTION		DxConflictCheckCriticalSection ;	// Փ˖h~pNeBJZNV
#endif
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// EChẼf[^
extern WINDATA WinData ;

// ֐vg^Cv錾-----------------------------------------------------------

// bnlAI֌W֐
extern	int			InitializeCom( void ) ;													// bnlC^[tF[X
extern	int			TerminateCom( void ) ;													// bnlC^[tF[XI

// In֐
extern int			InitializeWindow( void ) ;												// EChE֌W̏֐
extern int			TerminateWindow( void ) ;												// EChE֌W̏I֐

// o͌n
extern	int			OutSystemInfo( void ) ;													// nrcw̃o[W擾

// Փ˖h~p֐
//extern	void	PreparationDxFunction( void ) ;											// cwCuŌJ֐gpOɌĂԊ֐
extern	void		CheckConflictAndWaitDxFunction( void ) ;								// ɂcwCů֐Ă΂ĂȂ`FbNāAɌĂ΂Ă҂֐
extern	void		PostConflictProcessDxFunction( void ) ;									// CheckConfictAndWaitDxFunction gpcwCů֐ return OɌĂԂׂ֐

// \tg̃EChEɃtH[JXڂ
extern	void		SetAbsoluteForegroundWindow( HWND hWnd, int Flag = TRUE ) ;


// wchar_tŊ֐
extern	int			GetResourceInfo_WCHAR_T(			const wchar_t *ResourceName , const wchar_t *ResourceType , void **DataPointerP , int *DataSizeP ) ;
extern	int			GetPcInfo_WCHAR_T(					wchar_t *OSString , wchar_t *DirectXString , wchar_t *CPUString , int *CPUSpeed /* PMHz */ , double *FreeMemorySize /* PMByte */ , double *TotalMemorySize , wchar_t *VideoDriverFileName , wchar_t *VideoDriverString , double *FreeVideoMemorySize /* PMByte */ , double *TotalVideoMemorySize ) ;
extern	wchar_t		GetInputSystemChar_WCHAR_T(			int DeleteFlag ) ;
extern	int			LoadPauseGraph_WCHAR_T(				const wchar_t *FileName ) ;
extern	int			SetMainWindowText_WCHAR_T(			const wchar_t *WindowText ) ;
extern	int			SetMainWindowClassName_WCHAR_T(		const wchar_t *ClassName ) ;
extern	int			SetShutdownCallbackFunction_WCHAR_T(void (* CallbackFunction )( void * ), void *Data, const wchar_t *Message ) ;
extern	int			SetSysCommandOffFlag_WCHAR_T(		int Flag , const wchar_t *HookDllPath = NULL ) ;
extern	int			GetClipboardText_WCHAR_T(			wchar_t *DestBuffer ) ;
extern	int			SetClipboardText_WCHAR_T(			const wchar_t *Text ) ;
extern	int			GetDragFilePath_WCHAR_T(			wchar_t *FilePathBuffer ) ;
extern	int			SetWindowRgnGraph_WCHAR_T(			const wchar_t *FileName ) ;
extern	int			SetupToolBar_WCHAR_T(				const wchar_t *BitmapName , int DivNum , int ResourceID = -1 ) ;
extern	int			AddKeyAccel_WCHAR_T(				const wchar_t *ItemName , int ItemID , int KeyCode , int CtrlFlag , int AltFlag , int ShiftFlag ) ;
extern	int			AddKeyAccel_Name_WCHAR_T(			const wchar_t *ItemName , int KeyCode , int CtrlFlag , int AltFlag , int ShiftFlag ) ;
extern	int			AddMenuItem_WCHAR_T(				int AddType /* MENUITEM_ADD_CHILD */ , const wchar_t *ItemName, int ItemID, int SeparatorFlag, const wchar_t *NewItemName = NULL , int NewItemID = -1 ) ;
extern	int			DeleteMenuItem_WCHAR_T(				const wchar_t *ItemName, int ItemID ) ;
extern	int			CheckMenuItemSelect_WCHAR_T(		const wchar_t *ItemName, int ItemID ) ;
extern	int			SetMenuItemEnable_WCHAR_T(			const wchar_t *ItemName, int ItemID, int EnableFlag ) ;
extern	int			SetMenuItemMark_WCHAR_T(			const wchar_t *ItemName, int ItemID, int Mark ) ;
extern	int			AddMenuItem_Name_WCHAR_T(			const wchar_t *ParentItemName, const wchar_t *NewItemName ) ;
extern	int			AddMenuLine_Name_WCHAR_T(			const wchar_t *ParentItemName ) ;
extern	int			InsertMenuItem_Name_WCHAR_T(		const wchar_t *ItemName, const wchar_t *NewItemName ) ;
extern	int			InsertMenuLine_Name_WCHAR_T(		const wchar_t *ItemName ) ;
extern	int			DeleteMenuItem_Name_WCHAR_T(		const wchar_t *ItemName ) ;
extern	int			CheckMenuItemSelect_Name_WCHAR_T(	const wchar_t *ItemName ) ;
extern	int			SetMenuItemEnable_Name_WCHAR_T(		const wchar_t *ItemName, int EnableFlag ) ;
extern	int			SetMenuItemMark_Name_WCHAR_T(		const wchar_t *ItemName, int Mark ) ;
extern	int			AddMenuItem_ID_WCHAR_T(				int ParentItemID, const wchar_t *NewItemName, int NewItemID = -1 ) ;
extern	int			GetMenuItemID_WCHAR_T(				const wchar_t *ItemName ) ;
extern	int			GetMenuItemName_WCHAR_T(			int ItemID, wchar_t *NameBuffer ) ;


/*
extern __inline void PreparationDxFunction( void )
{
#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )
	// CJE^CNg
	WinData.DxConflictCheckCounter ++ ;
#endif
}
*/


// ݒn֐
extern	int			SetWindowModeFlag( int Flag ) ;											// EChE[hŋN邩Zbg
extern	int			SetWindowStyle( int CenterPosition = TRUE ) ;							// EChẼX^CZbg
extern	int			RefreshDragFileValidFlag( void ) ;										// t@C̃hbOhbv@\Lɂ邩ǂ̐ݒĐݒ肷


// 擾x
extern	PCINFO		*GetPcInfoStructP( void ) ;												// ob\̂̃AhX𓾂
extern	HWND		GetDisplayWindowHandle( void ) ;										// \ɎgpEChẼnh擾


// ֗֐
//extern	int			CheckConflict( int *Check_Inc_Counter ) ;									// }`Xbh̏Փ˂h߂̊֐
//extern	int			CheckConflict2( int *Check_NonInc_Counter, int *NonCheck_Inc_Counter ) ;	// }`Xbh̏Փ˂h߂̊֐2
//extern	int			CheckConflict3( int *Check_NonInc_Counter, int *Check_Inc_Counter ) ;		// }`Xbh̏Փ˂h߂̊֐3

// bZ[W֐
extern	void		DxActiveWait( void ) ;													// ANeBuɂȂ܂ŉȂ
extern	int			CheckActiveWait( void ) ;												// ANeBuǂ`FbN
extern	int			GetQuitMessageFlag( void ) ;											// WM_QUIT sĂ邩ǂ擾
extern	int			WM_ACTIVATEProcessUseStock( WPARAM wParam, LPARAM lParam, int APPMes = FALSE, int Dummy = FALSE ) ;
extern	int			WM_ACTIVATEProcess(         WPARAM wParam, LPARAM lParam, int APPMes = FALSE, int Dummy = FALSE ) ;

// Aero ̗LAݒ
extern	int			SetEnableAero( int Flag ) ;

// c[o[֌W
extern	int			GetToolBarHeight( void ) ;													// c[o[̍𓾂

// j[֌W
extern	int			MenuAutoDisplayProcess( void ) ;																// j[Iɕ\\ɂ肷鏈s

// ⏕֐
extern	void		_FileTimeToLocalDateData( FILETIME *FileTime, DATEDATA *DateData ) ;
extern	int			UpdateBackBufferTransColorWindow( const BASEIMAGE *SrcImage, const RECT *SrcImageRect = NULL, HDC Direct3DDC = NULL, int NotColorKey = FALSE, int PreMultipliedAlphaImage = FALSE ) ;	// ẘ{C[Wgp UpdateLayeredWindow s

// \[X֌W
extern	int			GetBmpImageToResource( int ResourceID, BITMAPINFO **BmpInfoP, void **GraphDataP ) ;					// alo\[X BITMAPINFO Ɖ摜C[W\z

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXWINDOW_H__
