// -------------------------------------------------------------------------------
// 
// 		cwCu		ff[^ǂݍݏSpwb_
// 
// 				Ver 3.17a
// 
// -------------------------------------------------------------------------------

#ifndef __DXMODELLOADER4_H__
#define __DXMODELLOADER4_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_MODEL

// CN[h ---------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxModel.h"
#include "DxModelRead.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -----------------------------------

#define PMX_MAX_IKLINKNUM		(64)			// ΉIKN̍ő吔

// f[^^` ---------------------------------

// PMXt@C̏i[\
struct PMX_BASEINFO
{
	BYTE	EncodeType ;						// R[h̃GR[h^Cv 0:UTF16 1:UTF8
	BYTE	UVNum ;								// ǉtu ( 0`4 )
	BYTE	VertexIndexSize ;					// _IndexTCY ( 1 or 2 or 4 )
	BYTE	TextureIndexSize ;					// eNX`IndexTCY ( 1 or 2 or 4 )
	BYTE	MaterialIndexSize ;					// }eAIndexTCY ( 1 or 2 or 4 )
	BYTE	BoneIndexSize ;						// {[IndexTCY ( 1 or 2 or 4 )
	BYTE	MorphIndexSize ;					// [tIndexTCY ( 1 or 2 or 4 )
	BYTE	RigidIndexSize ;					// IndexTCY ( 1 or 2 or 4 )
} ;

// _f[^
struct PMX_VERTEX
{
	float	Position[ 3 ] ;						// W
	float	Normal[ 3 ] ;						// @
	float	UV[ 2 ] ;							// WUVl
	float	AddUV[ 4 ][ 4 ] ;					// ǉUVl
	BYTE	WeightType ;						// EGCg^Cv( 0:BDEF1 1:BDEF2 2:BDEF4 3:SDEF )
	int		BoneIndex[ 4 ] ;					// {[CfbNX
	float	BoneWeight[ 4 ] ;					// {[EFCg
	float	SDEF_C[ 3 ] ;						// SDEF-C
	float	SDEF_R0[ 3 ] ;						// SDEF-R0
	float	SDEF_R1[ 3 ] ;						// SDEF-R1
	float	ToonEdgeScale ;						// gD[GbW̃XP[
} ;

// ʃXg
struct PMX_FACE
{
	int		VertexIndex[ 3 ] ;
} ;

// eNX`
struct PMX_TEXTURE
{
	wchar_t	TexturePath[ 512 ] ;
} ;

// }eA
struct PMX_MATERIAL
{
	wchar_t	Name[ 128 ] ;						// O

	float	Diffuse[ 4 ] ;						// fBt[YJ[
	float	Specular[ 3 ] ;						// XyLJ[
	float	SpecularPower ;						// XyL萔
	float	Ambient[ 3 ] ;						// ArGgJ[

	BYTE	CullingOff ;						// ʕ`
	BYTE	GroundShadow ;						// nʉe
	BYTE	SelfShadowMap ;						// ZtVhE}bvւ̕`
	BYTE	SelfShadowDraw ;					// ZtVhE̕`
	BYTE	EdgeDraw ;							// GbW̕`

	float	EdgeColor[ 4 ] ;					// GbWJ[
	float	EdgeSize ;							// GbWTCY

	int		TextureIndex ;						// ʏeNX`CfbNX
	int		SphereTextureIndex ;				// XtBAeNX`CfbNX
	BYTE	SphereMode ;						// XtBA[h( 0: 1:Z 2:Z 3:TueNX`(ǉUV1x,yUVQƂĒʏeNX``s)

	BYTE	ToonFlag ;							// LgD[tO( 0:Toon 1:LToon )
	int		ToonTextureIndex ;					// gD[eNX`CfbNX

	int		MaterialFaceNum ;					// }eAKĂʂ̐
} ;

// hjN
struct PMX_IKLINK
{
	int		BoneIndex ;							// N{[̃CfbNX
	BYTE	RotLockFlag ;						// ]( 0:OFF 1:ON )
	float	RotLockMin[ 3 ] ;					// ]A
	float	RotLockMax[ 3 ] ;					// ]A
} ;

// hj
struct PMX_IK
{
	int		TargetBoneIndex ;					// IK^[Qbg̃{[CfbNX
	int		LoopNum ;							// IKvZ̃[v
	float	RotLimit ;							// vZӂ̐px

	int		LinkNum ;							// hjN̐
	PMX_IKLINK Link[ PMX_MAX_IKLINKNUM ] ;		// hjN
} ;

// {[
struct PMX_BONE
{
	wchar_t	Name[ 128 ] ;						// O
	float	Position[ 3 ] ;						// W
	int		ParentBoneIndex ;					// e{[CfbNX
	int		TransformLayer ;					// ό`Kw
	
	BYTE	Flag_LinkDest ;						// ڑ
	BYTE	Flag_EnableRot ;					// ]ł邩
	BYTE	Flag_EnableMov ;					// ړł邩
	BYTE	Flag_Disp ;							// \
	BYTE	Flag_EnableControl ;				// 삪ł邩
	BYTE	Flag_IK ;							// IK
	BYTE	Flag_AddRot ;						// ]t^
	BYTE	Flag_AddMov ;						// ړt^
	BYTE	Flag_LockAxis ;						// Œ
	BYTE	Flag_LocalAxis ;					// [J
	BYTE	Flag_AfterPhysicsTransform ;		// ό`
	BYTE	Flag_OutParentTransform ;			// Oeό`

	float	OffsetPosition[ 3 ] ;				// ItZbgW
	int		LinkBoneIndex ;						// ڑ{[CfbNX
	int		AddParentBoneIndex ;				// t^e{[CfbNX
	float	AddRatio ;							// t^
	float	LockAxisVector[ 3 ] ;				// Œ莞̎̕xNg
	float	LocalAxisXVector[ 3 ] ;				// [Ĵw
	float	LocalAxisZVector[ 3 ] ;				// [Ĵy
	int		OutParentTransformKey ;				// Oeό` Keyl

	PMX_IK	IKInfo ;							// hj
} ;

// _[t
struct PMX_MORPH_VERTEX
{
	int		Index ;								// _CfbNX
	float	Offset[ 3 ] ;						// _WItZbg
} ;

// tu[t
struct PMX_MORPH_UV
{
	int		Index ;								// _CfbNX
	FLOAT4	Offset ;							// _tuItZbg
} ;

// {[[t
struct PMX_MORPH_BONE
{
	int		Index ;								// {[CfbNX
	float	Offset[ 3 ] ;						// WItZbg
	float	Quat[ 4 ] ;							// ]NH[^jI
} ;

// ގ[t
struct PMX_MORPH_MATERIAL
{
	int		Index ;								// }eACfbNX
	BYTE	CalcType ;							// vZ^Cv( 0:Z  1:Z )
	float	Diffuse[ 4 ] ;						// fBt[YJ[
	float	Specular[ 3 ] ;						// XyLJ[
	float	SpecularPower ;						// XyLW
	float	Ambient[ 3 ] ;						// ArGgJ[
	float	EdgeColor[ 4 ] ;					// GbWJ[
	float	EdgeSize ;							// GbWTCY
	float	TextureScale[ 4 ] ;					// eNX`W
	float	SphereTextureScale[ 4 ] ;			// XtBAeNX`W
	float	ToonTextureScale[ 4 ] ;				// gD[eNX`W
} ;

// O[v[t
struct PMX_MORPH_GROUP
{
	int		Index ;								// [tCfbNX
	float	Ratio ;								// [t
} ;

// [t
struct PMX_MORPH
{
	wchar_t	Name[ 128 ] ;						// O

	BYTE	ControlPanel ;						// pl
	BYTE	Type ;								// [t̎  0:O[v 1:_ 2:{[ 3:UV 4:ǉUV1 5:ǉUV2 6:ǉUV3 7:ǉUV4 8:ގ

	int		DataNum ;							// [t̐

	union
	{
		PMX_MORPH_VERTEX *Vertex ;				// _[t
		PMX_MORPH_UV *UV ;						// UV[t
		PMX_MORPH_BONE *Bone ;					// {[[t
		PMX_MORPH_MATERIAL *Material ;			// }eA[t
		PMX_MORPH_GROUP *Group ;				// O[v[t
	} ;
} ;

// ̏
struct PMX_RIGIDBODY
{
	wchar_t	Name[ 128 ] ;						// O

	int		BoneIndex ;							// Ώۃ{[ԍ

	BYTE	RigidBodyGroupIndex ;				// ̃O[vԍ
	WORD	RigidBodyGroupTarget ;				// ̃O[vΏ

	BYTE	ShapeType ;							// `( 0:  1:  2:JvZ )
	float	ShapeW ;							// 
	float	ShapeH ;							// 
	float	ShapeD ;							// s

	float	Position[ 3 ] ;						// ʒu
	float	Rotation[ 3 ] ;						// ]( WA )

	float	RigidBodyWeight ;					// 
	float	RigidBodyPosDim ;					// ړ
	float	RigidBodyRotDim ;					// ]
	float	RigidBodyRecoil ;					// 
	float	RigidBodyFriction ;					// C

	BYTE	RigidBodyType ;						// ̃^Cv( 0:BoneǏ]  1:Z  2:Z(Boneʒu킹) )
} ;

// WCg
struct PMX_JOINT
{
	wchar_t	Name[ 128 ] ;						// O

	BYTE	Type ;								// ( 0:XvO6DOF ( PMX2.0 ł 0 ̂ )

	int		RigidBodyAIndex ;					// ڑ捄̂`
	int		RigidBodyBIndex ;					// ڑ捄̂a

	float	Position[ 3 ] ;						// ʒu
	float	Rotation[ 3 ] ;						// ]( WA )

	float	ConstrainPositionMin[ 3 ] ;			// ړ-
	float	ConstrainPositionMax[ 3 ] ;			// ړ-
	float	ConstrainRotationMin[ 3 ] ;			// ]-
	float	ConstrainRotationMax[ 3 ] ;			// ]-

	float	SpringPosition[ 3 ] ;				// ol萔-ړ
	float	SpringRotation[ 3 ] ;				// ol萔-]
} ;

// VMDǂݍݏpPMX{[f[^
struct PMX_READ_BONE_INFO
{
	PMX_BONE			*Base ;					// {[f[^
	MV1_ANIM_R			*Anim ;					// ̃{[p̃Aj[Vւ̃|C^
	MV1_FRAME_R			*Frame ;				// ̃{[p̃t[ւ̃|C^

	VECTOR				*KeyPos ;				// WAj[VL[z̐擪
	FLOAT4				*KeyRot ;				// ]Aj[VL[z̐擪
	float				*KeyPosTime ;			// WAj[V^CL[z̐擪
	float				*KeyRotTime ;			// ]Aj[V^CL[z̐擪
	MATRIX				*KeyMatrix ;			// sAj[VL[z̐擪
	MATRIX				*KeyMatrix2 ;			// sAj[VL[z̐擪( IsIKChild  TRUE ̃{[p )

	int					IsPhysics ;				// gpĂ邩ǂ
	int					IsAddParent ;			// t^e@\gpĂ邩ǂ
	int					IsIK ;					// hj{[ǂ
	int					IsIKAnim ;				// hjAj[V邩ǂ
	int					IsIKChild ;				// hjAj[V{[̎q{[( hj̉e󂯂Ȃ{[ )ǂ
	MATRIX				LocalMatrix ;			// \z[Js
	int					SetupLocalWorldMatrix ;	// [J[hs񂪍\zĂ邩ǂ
	MATRIX				LocalWorldMatrix ;		// \z[J[hs
	VECTOR				Translate ;				// sړl
	FLOAT4				Rotate ;				// ]l
	VECTOR				OrgTranslate ;			// _̏ʒu

	MATRIX				IKmat ;					// IKŎgps\
	FLOAT4				IKQuat ;				// IKŎgpNH[^jI

	VECTOR				InitTranslate ;			// sړl̏l
	FLOAT4				InitRotate ;			// ]l̏l
#ifndef DX_NON_BULLET_PHYSICS
	int					PhysicsIndex ;			// Zp̔ԍ
	int					SetupPhysicsAnim ;		// {[Aj[Vtǂ
#endif

	struct VMD_READ_NODE_INFO	*Node ;			// {[Ɗ֘AtĂm[h
	struct VMD_READ_KEY_INFO	*NowKey ;		// ݍĐĂL[
} ;

// VMDǂݍݏpPMXIK{[f[^
struct PMX_READ_IK_INFO
{
	PMX_IK				*Base ;					// IK{[f[^
	PMX_READ_BONE_INFO	*Bone ;					// IK^[Qbg{[
	PMX_READ_BONE_INFO	*TargetBone ;			// IK[{[

//	WORD				LimitAngleIK ;			// px{[܂܂ꂽhjǂ( 0:Ⴄ 1: ) 
//	WORD				Iterations ;			// ċNZ
//	float				ControlWeight ;			// IK̉ex
//	float				IKTotalLength ;			// IK̍`FC̍Ō܂ł̋

//	int					ChainBoneNum ;			// IK`F[̒(q̐)
//	WORD				*ChainBone ;			// IKẽ{[ւ̃CfbNXzւ̃|C^

	PMX_READ_IK_INFO	*Prev ;					// Xg̑Õf[^ւ̃AhX
	PMX_READ_IK_INFO	*Next ;					// Xg̎̃f[^ւ̃AhX
} ;

// PMXǂݍݏpZpf[^
struct PMX_READ_PHYSICS_INFO
{
	PMX_RIGIDBODY		*Base ;					// f[^

	PMX_READ_BONE_INFO	*Bone ;					// {[̏ւ̃|C^
	bool				NoCopyToBone ;			// {[֍̂̏Ԃ킷sRs[Ȃǂ

	DWORD				BulletInfo[ 320 ] ;		// BULLET_RIGIDBODY_INFO i[obt@
} ;

// PMXǂݍݏpPMDZpWCgf[^
struct PMX_READ_PHYSICS_JOINT_INFO
{
	PMX_JOINT			*Base ;					// WCgf[^

	DWORD				BulletInfo[ 32 ] ;		// BULLET_JOINT_INFO i[obt@
} ;

// olwǂݍݏ̕֌W̏Z߂\
struct DX_MODELLOADER3_PMX_PHYSICS_INFO
{
	VECTOR Gravity ;
	int MotionTotalFrameNum ;

	int LoopMotionFlag ;
	int LoopMotionNum ;

	int	PhysicsCalcPrecision ;

	int PmxPhysicsNum ;
	PMX_READ_PHYSICS_INFO *PmxPhysicsInfoDim ;

	int PmxPhysicsJointNum ;
	PMX_READ_PHYSICS_JOINT_INFO *PmxPhysicsJointInfoDim ;

	MV1_ANIMKEYSET_R *KeyMatrixSet ;

	DWORD BulletPhysicsDataBuffer[ 32 ] ;			// BULLET_PHYSICS i[obt@
} ;


// ֐錾 -------------------------------------

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#ifndef DX_NON_BULLET_PHYSICS

extern int SetupPhysicsObject_PMXPhysicsInfo(		DX_MODELLOADER3_PMX_PHYSICS_INFO *MLPhysicsInfoint, int DisablePhysicsFile ) ;
extern int ReleasePhysicsObject_PMXPhysicsInfo(		DX_MODELLOADER3_PMX_PHYSICS_INFO *MLPhysicsInfo ) ;
extern int OneFrameProcess_PMXPhysicsInfo(			DX_MODELLOADER3_PMX_PHYSICS_INFO *MLPhysicsInfo, int FrameNo, int LoopNo, bool FPS60, int ValidNextRate, int TimeDivNum ) ;
extern int CheckDisablePhysicsAnim_PMXPhysicsInfo(	DX_MODELLOADER3_PMX_PHYSICS_INFO *MLPhysicsInfo, int PhysicsIndex ) ;

#endif


#endif
#endif
